$fn=0; $fa=0.01; //Disable $fn and $fa, do not change these.
$fs=0.8;  // fine: 0.1  medium: 0.5  coarse: 1


x=106;
y=46.4;
boden=2.8;

lochAbstX=39;
lochAbstY=19;
bohr=2.8;
scheibeZ=2.5;
scheibeD=5.5;

midiX=26;

stege=9+1;
stegeAbst=86.6;
stegeZ=2.8;

module nano() {
    nx=17.62+0.9;
    ny=43.6+0.9;
    usbx=7.8+0.6;
    usbZ=3.8+stegeZ;
    wand=1.201;
    w2=wand*2;
    difference() {
        union() {
//            translate([wand,wand,0])
            cube([nx+w2, ny+w2, usbZ+boden]);
            
            translate([-1.5,4,0])
            cylinder(d=1.6*2+3, h=usbZ+boden);
            
            translate([nx+1.5+w2,4,0])
            cylinder(d=1.6*2+3, h=usbZ+boden);

            translate([-1.5,ny-7,0])
            cylinder(d=1.6*2+3, h=usbZ+boden);
            
            translate([nx+1.5+w2,ny-7,0])
            cylinder(d=1.6*2+3, h=usbZ+boden);
            
        }

        translate([-1.5,4,0])
        cylinder(d=bohr, h=29);
        translate([nx+1.5+w2,4,0])
        cylinder(d=bohr, h=19);

        translate([-1.5,ny-7,0])
        cylinder(d=bohr, h=19);
        translate([nx+1.5+w2,ny-7,0])
        cylinder(d=bohr, h=19);



        translate([wand,wand,0.01])
        cube([nx, ny, 19]);

        translate([wand + nx/2- usbx/2 ,wand+ny-0.01,-0.01])
        cube([usbx, 9, 19]);
        
    }
    translate([nx/2-5+wand, ny/2-12+wand])
    cube([2.4,35,boden+stegeZ]);

    translate([nx/2+5-wand, ny/2-12+wand])
    cube([2.4,35,boden+stegeZ]);
}

difference() {
    union() {
        color("red")
        translate([x-21, 0,0])
        nano();
        
        color("orange")
        cube([x,y,boden]);   

        color("green")
        translate([midiX+4.5, 12,boden]){
            cylinder(d=scheibeD, h=scheibeZ);

            translate([lochAbstX,0,0])
            cylinder(d=scheibeD, h=scheibeZ);

            translate([0,lochAbstY,0])
            cylinder(d=scheibeD, h=scheibeZ);

            translate([lochAbstX,lochAbstY,0])
            cylinder(d=scheibeD, h=scheibeZ);
        }
        
        color("pink")
        hull() {
            
        translate([0,y/2-13,0])
            cube([12,26,2]);

            translate([0,y/2,10.5])
            scale([1,1.5,1])
            rotate([0,90,0])
            cylinder(d=20, h=7);
        }
    }
    //........
    
    
    color("magenta")
    translate([-0.01,y/2,10.5]){
        rotate([0,90,0])
        cylinder(d=14.7+0.5, h=19);

        translate([0,22.5/2,0])        
        rotate([0,90,0])
        cylinder(d=2.7, h=19);

        translate([0,-22.5/2,0])        
        rotate([0,90,0])
        cylinder(d=2.7, h=19);
    }
        
    
    translate([midiX+4.5, 12,-0.01]){
        
        cylinder(d=bohr, h=9);

        translate([lochAbstX,0,0])
        cylinder(d=bohr, h=9);

        translate([0,lochAbstY,0])
        cylinder(d=bohr, h=9);

        translate([lochAbstX,lochAbstY,0])
        cylinder(d=bohr, h=9);
    }
    
    //Befestigung Messing
    translate([80.5,15,-0.1])
    cylinder(d=3.6, h=9);

    translate([80.5-57,15,-0.1])
    cylinder(d=3.6, h=9);

    //Aussparung Stege
    hull(){
        translate([x/2-stegeAbst/2, stege/2,-0.01])
        cylinder(d=stege, h=stegeZ+0.02);
        translate([x/2-stegeAbst/2, 0,-0.01])
        cylinder(d=stege, h=stegeZ+0.02);
    }

    hull(){
        translate([x/2+stegeAbst/2, stege/2,-0.01])
        cylinder(d=stege, h=stegeZ+0.02);
        translate([x/2+stegeAbst/2, 0,-0.01])
        cylinder(d=stege, h=stegeZ+0.02);
    }
    translate([23,5,boden-0.5])
    linear_extrude(height = 1.0) {
        text(text = "ZABEX", font = "Liberation Sans:style=Bold Italic", size = 7, valign ="center");
        /*top center baseline bottom    Fonts:  Help > Font List*/ 
}
    
}