$fn=0; $fa=0.01; //Disable $fn and $fa, do not change these.
$fs=0.8;  // fine: 0.1  medium: 0.5  coarse: 1


silencerD=30;
wallthickness=2.03;
wand=2.01;
wand2=wand*2;

adaptor_len=35;
barrel_dia=16;

mouthpiece=16; //hole diameter in Alt-Sax mouthpiece
tube_len=30;
tubeLen1=105;



adaptorZ=tube_len+15;




g1=0.01;
g2=0.02;
g3=0.03;



module silencer () {
	difference () {
		union () {
            color("green")
			translate ([0,0,tube_len-3])
            cylinder(d=20+wand2, h=16);
            
            color("red")
			translate ([0,0,tube_len-g1])
			cylinder(h=adaptorZ-tube_len+g3, d1=mouthpiece, d2=silencerD);
            
            color("orange")
			cylinder(h=tube_len+g2,d=mouthpiece);
            
		}
        //.................
        color("green")
		translate ([0,0,-0.01]) 
			cylinder(h=tube_len+0.1,d=mouthpiece-wand2);
		// Kegel zur ersten Stufe
        color("white")
		translate ([0,0,tube_len-0.01])
				cylinder(h=adaptorZ-tube_len+0.1,d1=mouthpiece-wand2,d2=silencerD-wand*2);
            
			// Spalt im Rohr
			cube([mouthpiece,1.5,tube_len*2-2], center=true);

            //Ring für Mundstück aussen
   			translate ([0,0,tube_len-3.01])
            difference() {
                cylinder(d1=20.7,d2=19.2, h=3.1);
                translate([0,0,-0.01])
                cylinder(d=mouthpiece, h=3.3);
            }
	}
}



translate([0,0,adaptorZ+tubeLen1+5])
rotate([180,0,0])
silencer();	
*difference () {	silencer();	translate([0,-50,-1])  cube([50,50,190]);}

translate([0,0,5])
difference() {
    union() {
        color("cyan")
        cylinder(d=silencerD, h=tubeLen1);
        cylinder(d=silencerD, h=5); 
    }
    
    color("pink")
    translate([0,0,22]) //Oberer Rohrteil
    cylinder(d=silencerD-2*wallthickness, h=tubeLen1+9);

    color("skyblue")
    translate([0,0,5]) //Bodendicke
    difference() {
       cylinder(d=silencerD-2*wallthickness, h=22-5-4);
       cylinder(d=6+2*2, h=22-5-4-9);
    }    
    color("magenta")
    translate([0,0,-0.01])
    cylinder(d=6, h=18);


    translate([-5,-5,5+9]) //Zwischenbodenloch
    cylinder(d=6, h=9);


    //Schnittbild
    *translate([0,0,-1])  cube([50,50,150]);

}
//Stützen
for (i=[0:3]) {
    rotate([0,0,135+i*90])
    translate([-0.4,3,5])
    cube([0.8,2,20]);
}

//Innenrohr
translate([0,0,25])
difference() {
    union() {
        cylinder(d=silencerD-6, h=tubeLen1-20);        
    }
     cylinder(d=silencerD-6-2*1.21, h=159);        
    *translate([0,0,-1])  cube([50,50,150]);
}

color("red")
difference() {
    translate([0,0,5])
    for (i=[0:360/7:360]) {
        rotate([0,0,i])
        translate([silencerD/2,0,0])
        cylinder(d=wand2, h=tubeLen1-2);
        
        rotate([0,0,i])
        translate([10.9,0,0])
        cylinder(d=2.4, h=tubeLen1+6);

        rotate([0,0,i])
        translate([4,-0.4,0])
        cube([9,0.8,9]);
        
        
    }
    *cube([100,100,100]);
}
