$fn=0; $fa=0.01; //Disable $fn and $fa, do not change these.
$fs=1.0;  // fine: 0.1  medium: 0.5  coarse: 1


ls1=50.5;
ls2=113;
ls3=2.5;

rahmenx=127;
rahmeny=57.8;

m=(ls2-ls1) /2;
module rohr(){
    difference() {
        union() {
             cylinder(d=16+1.6*2,h=25);   
        }
        translate([0,0,-0.01])
        cylinder(d=16,h=30);
    }
}


module rohrInnen(){
        translate([0,0,-0.01])
        cylinder(d=16,h=1.1);
}
module rohrAussen(){
       cylinder(d=16+1.6*2,h=1);   
}



module ls(){
    difference() {
        union() {
            translate([-rahmenx/2,-rahmeny/2,0])
            cube([rahmenx,rahmeny,2]);
            translate([-ls2/2+ls1/2,0,0])
            hull(){
                cylinder(d=ls1+ls3*2, h=1.5);
                translate([ls2-ls1,0,0])
                cylinder(d=ls1+ls3*2, h=1.5);
            }
        }
        translate([ls1/2-ls2/2,0,-0.1])
        hull(){
            cylinder(d=ls1, h=5);
            translate([ls2-ls1,0,0])
            cylinder(d=ls1, h=5);
        }
        translate([rahmenx/2-5,rahmeny/2-5,-0.1])
        cylinder(d=5.2, h=9);
        translate([-rahmenx/2+5,rahmeny/2-5,-0.1])
        cylinder(d=5.2, h=9);
        translate([rahmenx/2-5,-rahmeny/2+5,-0.1])
        cylinder(d=5.2, h=9);
        translate([-rahmenx/2+5,-rahmeny/2+5,-0.1])
        cylinder(d=5.2, h=9);
    }
    
    //translate([-ls1/2,0,0])cube([ls2,1,5]); //Kontrolle
}

module lsInnen(){
        translate([ls1/2-ls2/2,0,-0.1])
        hull(){
            cylinder(d=ls1, h=1.55);
            translate([ls2-ls1,0,0])
            cylinder(d=ls1, h=1.55);
        }
}

module lsAussen() {
    translate([-ls2/2+ls1/2,0,0])
    hull(){
        cylinder(d=ls1+ls3*2, h=1.5);
        translate([ls2-ls1,0,0])
        cylinder(d=ls1+ls3*2, h=1.5);
    }
}

//intersection() {    cube([100,100,100]);

difference() {
    union() {
        ls();
        translate([0,0,40]) 
            rohr();
        hull(){
            lsAussen();
            translate([0,0,42]) 
            rohrAussen();
        }
        
    }
    hull(){
        lsInnen();
        translate([0,0,40]) 
        rohrInnen();
    }
        translate([0,0,39])
        cylinder(d=16,h=9);

}



//translate([0,0,40]) 

//cylinder(d=16+1.6*2,h=2);   
//rohr();

//}